library search_helper;

import 'dart:convert';

class SearchHelper{


  static List<Map<String,dynamic>> wordSearch({List<Map<String,dynamic>> data= const[],
    List<String> keys = const [],
    var searchWord
  }){
    List<Map<String,dynamic>> filtered = [];


    filtered.clear();


    for(int i=0;i<keys.length;i++){

      filtered.addAll(data.where((e)=> e[keys[i]] == searchWord).toList());

    }

    return filtered.toSet().toList();
  }

  static List<Map<String,dynamic>> stringInstantSearch({List<Map<String,dynamic>> data= const [],
    List<String> keys = const [],
    var searchWord
  }){
    List<Map<String,dynamic>> filtered = [];

    filtered.clear();


    for(int i=0;i<keys.length;i++){

      filtered.addAll(data.where((e)=> e[keys[i]].toString().toLowerCase().contains(searchWord.toString().toLowerCase())).toList());

    }

    return filtered.toSet().toList();
  }

  static searchModel({var data= const[],
    List<String> properties = const [],
    Map<String,String> innerObject = const {},
    var searchWord,
  }){


    String jsonString = jsonEncode(data);
    var  jsonData = jsonDecode(jsonString);

    var filtered = [];


    filtered.clear();



    try{
      if(properties.isNotEmpty){
        for(int i=0;i<properties.length;i++){

          filtered.addAll(jsonData.where((e)=> e[properties[i]].toString().toLowerCase().contains(searchWord.toString().toLowerCase())).toList());

        }
      }else{


        innerObject.keys.forEach((key) {

          final value = innerObject[key];

          filtered.addAll(jsonData.where((e)=> e[key][value].toString().toLowerCase().contains(searchWord.toString().toLowerCase())).toList());


        });


      }
    }catch(e){
      print("Error is $e");
    }

    return filtered.toSet().toList();
  }


}